// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/EnergyFactors.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Electricity {

  /// <summary>Holder for reflection information generated from telemetry/EnergyFactors.proto</summary>
  public static partial class EnergyFactorsReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/EnergyFactors.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static EnergyFactorsReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Ch10ZWxlbWV0cnkvRW5lcmd5RmFjdG9ycy5wcm90bxILZWxlY3RyaWNpdHki",
            "rwYKDUVuZXJneUZhY3RvcnMSIwoWYWN0aXZlX2VuZXJneV9pbXBvcnRlZBgB",
            "IAEoCUgAiAEBEiMKFmFjdGl2ZV9lbmVyZ3lfZXhwb3J0ZWQYAiABKAlIAYgB",
            "ARIvCiJpbmR1Y3RpdmVfcmVhY3RpdmVfZW5lcmd5X2ltcG9ydGVkGAMgASgJ",
            "SAKIAQESLwoiaW5kdWN0aXZlX3JlYWN0aXZlX2VuZXJneV9leHBvcnRlZBgE",
            "IAEoCUgDiAEBEi4KIWNhcGFjaXR5X3JlYWN0aXZlX2VuZXJneV9pbXBvcnRl",
            "ZBgFIAEoCUgEiAEBEi4KIWNhcGFjaXR5X3JlYWN0aXZlX2VuZXJneV9leHBv",
            "cnRlZBgGIAEoCUgFiAEBEhwKD2FwcGFyZW50X2VuZXJneRgHIAEoCUgGiAEB",
            "EjoKC3NhbXBsZV90eXBlGBQgASgOMiUuZWxlY3RyaWNpdHkuRW5lcmd5RmFj",
            "dG9ycy5TYW1wbGVUeXBlEi8KBXBoYXNlGBUgASgOMiAuZWxlY3RyaWNpdHku",
            "RW5lcmd5RmFjdG9ycy5QaGFzZSInCgpTYW1wbGVUeXBlEgcKA0FWRxAAEgcK",
            "A01JThABEgcKA01BWBACInoKBVBoYXNlEgYKAkwxEAASBgoCTDIQARIGCgJM",
            "MxACEggKBEwxX04QAxIICgRMMl9OEAQSCAoETDNfThAFEggKBFBFX04QBhIF",
            "CgFOEAcSCQoFTDFfTDIQCBIJCgVMMl9MMxAJEgkKBUwzX0wxEAoSCQoFVE9U",
            "QUwQC0IZChdfYWN0aXZlX2VuZXJneV9pbXBvcnRlZEIZChdfYWN0aXZlX2Vu",
            "ZXJneV9leHBvcnRlZEIlCiNfaW5kdWN0aXZlX3JlYWN0aXZlX2VuZXJneV9p",
            "bXBvcnRlZEIlCiNfaW5kdWN0aXZlX3JlYWN0aXZlX2VuZXJneV9leHBvcnRl",
            "ZEIkCiJfY2FwYWNpdHlfcmVhY3RpdmVfZW5lcmd5X2ltcG9ydGVkQiQKIl9j",
            "YXBhY2l0eV9yZWFjdGl2ZV9lbmVyZ3lfZXhwb3J0ZWRCEgoQX2FwcGFyZW50",
            "X2VuZXJneUJ5Chtjb20uY29kaWJseS5tb2RlbC50ZWxlbWV0cnlCEkVuZXJn",
            "eUZhY3RvcnNQcm90b8oCG0RvbWFpbk1vZGVsXFByb3RvXFRlbGVtZXRyeeIC",
            "J0RvbWFpbk1vZGVsXFByb3RvXFRlbGVtZXRyeVxHUEJNZXRhZGF0YWIGcHJv",
            "dG8z"));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Electricity.EnergyFactors), global::Electricity.EnergyFactors.Parser, new[]{ "ActiveEnergyImported", "ActiveEnergyExported", "InductiveReactiveEnergyImported", "InductiveReactiveEnergyExported", "CapacityReactiveEnergyImported", "CapacityReactiveEnergyExported", "ApparentEnergy", "SampleType", "Phase" }, new[]{ "ActiveEnergyImported", "ActiveEnergyExported", "InductiveReactiveEnergyImported", "InductiveReactiveEnergyExported", "CapacityReactiveEnergyImported", "CapacityReactiveEnergyExported", "ApparentEnergy" }, new[]{ typeof(global::Electricity.EnergyFactors.Types.SampleType), typeof(global::Electricity.EnergyFactors.Types.Phase) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class EnergyFactors : pb::IMessage<EnergyFactors>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<EnergyFactors> _parser = new pb::MessageParser<EnergyFactors>(() => new EnergyFactors());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<EnergyFactors> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Electricity.EnergyFactorsReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public EnergyFactors() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public EnergyFactors(EnergyFactors other) : this() {
      activeEnergyImported_ = other.activeEnergyImported_;
      activeEnergyExported_ = other.activeEnergyExported_;
      inductiveReactiveEnergyImported_ = other.inductiveReactiveEnergyImported_;
      inductiveReactiveEnergyExported_ = other.inductiveReactiveEnergyExported_;
      capacityReactiveEnergyImported_ = other.capacityReactiveEnergyImported_;
      capacityReactiveEnergyExported_ = other.capacityReactiveEnergyExported_;
      apparentEnergy_ = other.apparentEnergy_;
      sampleType_ = other.sampleType_;
      phase_ = other.phase_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public EnergyFactors Clone() {
      return new EnergyFactors(this);
    }

    /// <summary>Field number for the "active_energy_imported" field.</summary>
    public const int ActiveEnergyImportedFieldNumber = 1;
    private string activeEnergyImported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActiveEnergyImported {
      get { return activeEnergyImported_ ?? ""; }
      set {
        activeEnergyImported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "active_energy_imported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasActiveEnergyImported {
      get { return activeEnergyImported_ != null; }
    }
    /// <summary>Clears the value of the "active_energy_imported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearActiveEnergyImported() {
      activeEnergyImported_ = null;
    }

    /// <summary>Field number for the "active_energy_exported" field.</summary>
    public const int ActiveEnergyExportedFieldNumber = 2;
    private string activeEnergyExported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActiveEnergyExported {
      get { return activeEnergyExported_ ?? ""; }
      set {
        activeEnergyExported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "active_energy_exported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasActiveEnergyExported {
      get { return activeEnergyExported_ != null; }
    }
    /// <summary>Clears the value of the "active_energy_exported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearActiveEnergyExported() {
      activeEnergyExported_ = null;
    }

    /// <summary>Field number for the "inductive_reactive_energy_imported" field.</summary>
    public const int InductiveReactiveEnergyImportedFieldNumber = 3;
    private string inductiveReactiveEnergyImported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string InductiveReactiveEnergyImported {
      get { return inductiveReactiveEnergyImported_ ?? ""; }
      set {
        inductiveReactiveEnergyImported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "inductive_reactive_energy_imported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasInductiveReactiveEnergyImported {
      get { return inductiveReactiveEnergyImported_ != null; }
    }
    /// <summary>Clears the value of the "inductive_reactive_energy_imported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearInductiveReactiveEnergyImported() {
      inductiveReactiveEnergyImported_ = null;
    }

    /// <summary>Field number for the "inductive_reactive_energy_exported" field.</summary>
    public const int InductiveReactiveEnergyExportedFieldNumber = 4;
    private string inductiveReactiveEnergyExported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string InductiveReactiveEnergyExported {
      get { return inductiveReactiveEnergyExported_ ?? ""; }
      set {
        inductiveReactiveEnergyExported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "inductive_reactive_energy_exported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasInductiveReactiveEnergyExported {
      get { return inductiveReactiveEnergyExported_ != null; }
    }
    /// <summary>Clears the value of the "inductive_reactive_energy_exported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearInductiveReactiveEnergyExported() {
      inductiveReactiveEnergyExported_ = null;
    }

    /// <summary>Field number for the "capacity_reactive_energy_imported" field.</summary>
    public const int CapacityReactiveEnergyImportedFieldNumber = 5;
    private string capacityReactiveEnergyImported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string CapacityReactiveEnergyImported {
      get { return capacityReactiveEnergyImported_ ?? ""; }
      set {
        capacityReactiveEnergyImported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "capacity_reactive_energy_imported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCapacityReactiveEnergyImported {
      get { return capacityReactiveEnergyImported_ != null; }
    }
    /// <summary>Clears the value of the "capacity_reactive_energy_imported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCapacityReactiveEnergyImported() {
      capacityReactiveEnergyImported_ = null;
    }

    /// <summary>Field number for the "capacity_reactive_energy_exported" field.</summary>
    public const int CapacityReactiveEnergyExportedFieldNumber = 6;
    private string capacityReactiveEnergyExported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string CapacityReactiveEnergyExported {
      get { return capacityReactiveEnergyExported_ ?? ""; }
      set {
        capacityReactiveEnergyExported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "capacity_reactive_energy_exported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCapacityReactiveEnergyExported {
      get { return capacityReactiveEnergyExported_ != null; }
    }
    /// <summary>Clears the value of the "capacity_reactive_energy_exported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCapacityReactiveEnergyExported() {
      capacityReactiveEnergyExported_ = null;
    }

    /// <summary>Field number for the "apparent_energy" field.</summary>
    public const int ApparentEnergyFieldNumber = 7;
    private string apparentEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ApparentEnergy {
      get { return apparentEnergy_ ?? ""; }
      set {
        apparentEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "apparent_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasApparentEnergy {
      get { return apparentEnergy_ != null; }
    }
    /// <summary>Clears the value of the "apparent_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearApparentEnergy() {
      apparentEnergy_ = null;
    }

    /// <summary>Field number for the "sample_type" field.</summary>
    public const int SampleTypeFieldNumber = 20;
    private global::Electricity.EnergyFactors.Types.SampleType sampleType_ = global::Electricity.EnergyFactors.Types.SampleType.Avg;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.EnergyFactors.Types.SampleType SampleType {
      get { return sampleType_; }
      set {
        sampleType_ = value;
      }
    }

    /// <summary>Field number for the "phase" field.</summary>
    public const int PhaseFieldNumber = 21;
    private global::Electricity.EnergyFactors.Types.Phase phase_ = global::Electricity.EnergyFactors.Types.Phase.L1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.EnergyFactors.Types.Phase Phase {
      get { return phase_; }
      set {
        phase_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as EnergyFactors);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(EnergyFactors other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (ActiveEnergyImported != other.ActiveEnergyImported) return false;
      if (ActiveEnergyExported != other.ActiveEnergyExported) return false;
      if (InductiveReactiveEnergyImported != other.InductiveReactiveEnergyImported) return false;
      if (InductiveReactiveEnergyExported != other.InductiveReactiveEnergyExported) return false;
      if (CapacityReactiveEnergyImported != other.CapacityReactiveEnergyImported) return false;
      if (CapacityReactiveEnergyExported != other.CapacityReactiveEnergyExported) return false;
      if (ApparentEnergy != other.ApparentEnergy) return false;
      if (SampleType != other.SampleType) return false;
      if (Phase != other.Phase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasActiveEnergyImported) hash ^= ActiveEnergyImported.GetHashCode();
      if (HasActiveEnergyExported) hash ^= ActiveEnergyExported.GetHashCode();
      if (HasInductiveReactiveEnergyImported) hash ^= InductiveReactiveEnergyImported.GetHashCode();
      if (HasInductiveReactiveEnergyExported) hash ^= InductiveReactiveEnergyExported.GetHashCode();
      if (HasCapacityReactiveEnergyImported) hash ^= CapacityReactiveEnergyImported.GetHashCode();
      if (HasCapacityReactiveEnergyExported) hash ^= CapacityReactiveEnergyExported.GetHashCode();
      if (HasApparentEnergy) hash ^= ApparentEnergy.GetHashCode();
      if (SampleType != global::Electricity.EnergyFactors.Types.SampleType.Avg) hash ^= SampleType.GetHashCode();
      if (Phase != global::Electricity.EnergyFactors.Types.Phase.L1) hash ^= Phase.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasActiveEnergyImported) {
        output.WriteRawTag(10);
        output.WriteString(ActiveEnergyImported);
      }
      if (HasActiveEnergyExported) {
        output.WriteRawTag(18);
        output.WriteString(ActiveEnergyExported);
      }
      if (HasInductiveReactiveEnergyImported) {
        output.WriteRawTag(26);
        output.WriteString(InductiveReactiveEnergyImported);
      }
      if (HasInductiveReactiveEnergyExported) {
        output.WriteRawTag(34);
        output.WriteString(InductiveReactiveEnergyExported);
      }
      if (HasCapacityReactiveEnergyImported) {
        output.WriteRawTag(42);
        output.WriteString(CapacityReactiveEnergyImported);
      }
      if (HasCapacityReactiveEnergyExported) {
        output.WriteRawTag(50);
        output.WriteString(CapacityReactiveEnergyExported);
      }
      if (HasApparentEnergy) {
        output.WriteRawTag(58);
        output.WriteString(ApparentEnergy);
      }
      if (SampleType != global::Electricity.EnergyFactors.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.EnergyFactors.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasActiveEnergyImported) {
        output.WriteRawTag(10);
        output.WriteString(ActiveEnergyImported);
      }
      if (HasActiveEnergyExported) {
        output.WriteRawTag(18);
        output.WriteString(ActiveEnergyExported);
      }
      if (HasInductiveReactiveEnergyImported) {
        output.WriteRawTag(26);
        output.WriteString(InductiveReactiveEnergyImported);
      }
      if (HasInductiveReactiveEnergyExported) {
        output.WriteRawTag(34);
        output.WriteString(InductiveReactiveEnergyExported);
      }
      if (HasCapacityReactiveEnergyImported) {
        output.WriteRawTag(42);
        output.WriteString(CapacityReactiveEnergyImported);
      }
      if (HasCapacityReactiveEnergyExported) {
        output.WriteRawTag(50);
        output.WriteString(CapacityReactiveEnergyExported);
      }
      if (HasApparentEnergy) {
        output.WriteRawTag(58);
        output.WriteString(ApparentEnergy);
      }
      if (SampleType != global::Electricity.EnergyFactors.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.EnergyFactors.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasActiveEnergyImported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActiveEnergyImported);
      }
      if (HasActiveEnergyExported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActiveEnergyExported);
      }
      if (HasInductiveReactiveEnergyImported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(InductiveReactiveEnergyImported);
      }
      if (HasInductiveReactiveEnergyExported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(InductiveReactiveEnergyExported);
      }
      if (HasCapacityReactiveEnergyImported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(CapacityReactiveEnergyImported);
      }
      if (HasCapacityReactiveEnergyExported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(CapacityReactiveEnergyExported);
      }
      if (HasApparentEnergy) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ApparentEnergy);
      }
      if (SampleType != global::Electricity.EnergyFactors.Types.SampleType.Avg) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) SampleType);
      }
      if (Phase != global::Electricity.EnergyFactors.Types.Phase.L1) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) Phase);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(EnergyFactors other) {
      if (other == null) {
        return;
      }
      if (other.HasActiveEnergyImported) {
        ActiveEnergyImported = other.ActiveEnergyImported;
      }
      if (other.HasActiveEnergyExported) {
        ActiveEnergyExported = other.ActiveEnergyExported;
      }
      if (other.HasInductiveReactiveEnergyImported) {
        InductiveReactiveEnergyImported = other.InductiveReactiveEnergyImported;
      }
      if (other.HasInductiveReactiveEnergyExported) {
        InductiveReactiveEnergyExported = other.InductiveReactiveEnergyExported;
      }
      if (other.HasCapacityReactiveEnergyImported) {
        CapacityReactiveEnergyImported = other.CapacityReactiveEnergyImported;
      }
      if (other.HasCapacityReactiveEnergyExported) {
        CapacityReactiveEnergyExported = other.CapacityReactiveEnergyExported;
      }
      if (other.HasApparentEnergy) {
        ApparentEnergy = other.ApparentEnergy;
      }
      if (other.SampleType != global::Electricity.EnergyFactors.Types.SampleType.Avg) {
        SampleType = other.SampleType;
      }
      if (other.Phase != global::Electricity.EnergyFactors.Types.Phase.L1) {
        Phase = other.Phase;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            ActiveEnergyImported = input.ReadString();
            break;
          }
          case 18: {
            ActiveEnergyExported = input.ReadString();
            break;
          }
          case 26: {
            InductiveReactiveEnergyImported = input.ReadString();
            break;
          }
          case 34: {
            InductiveReactiveEnergyExported = input.ReadString();
            break;
          }
          case 42: {
            CapacityReactiveEnergyImported = input.ReadString();
            break;
          }
          case 50: {
            CapacityReactiveEnergyExported = input.ReadString();
            break;
          }
          case 58: {
            ApparentEnergy = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.EnergyFactors.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.EnergyFactors.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            ActiveEnergyImported = input.ReadString();
            break;
          }
          case 18: {
            ActiveEnergyExported = input.ReadString();
            break;
          }
          case 26: {
            InductiveReactiveEnergyImported = input.ReadString();
            break;
          }
          case 34: {
            InductiveReactiveEnergyExported = input.ReadString();
            break;
          }
          case 42: {
            CapacityReactiveEnergyImported = input.ReadString();
            break;
          }
          case 50: {
            CapacityReactiveEnergyExported = input.ReadString();
            break;
          }
          case 58: {
            ApparentEnergy = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.EnergyFactors.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.EnergyFactors.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the EnergyFactors message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum SampleType {
        [pbr::OriginalName("AVG")] Avg = 0,
        [pbr::OriginalName("MIN")] Min = 1,
        [pbr::OriginalName("MAX")] Max = 2,
      }

      public enum Phase {
        [pbr::OriginalName("L1")] L1 = 0,
        [pbr::OriginalName("L2")] L2 = 1,
        [pbr::OriginalName("L3")] L3 = 2,
        [pbr::OriginalName("L1_N")] L1N = 3,
        [pbr::OriginalName("L2_N")] L2N = 4,
        [pbr::OriginalName("L3_N")] L3N = 5,
        [pbr::OriginalName("PE_N")] PeN = 6,
        [pbr::OriginalName("N")] N = 7,
        [pbr::OriginalName("L1_L2")] L1L2 = 8,
        [pbr::OriginalName("L2_L3")] L2L3 = 9,
        [pbr::OriginalName("L3_L1")] L3L1 = 10,
        [pbr::OriginalName("TOTAL")] Total = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
